package net.hostsharing.hsadminng.rbac.rbacdef;

import static net.hostsharing.hsadminng.rbac.rbacdef.StringWriter.with;

public class RbacIdentityViewGenerator {
    private final RbacView rbacDef;
    private final String liquibaseTagPrefix;
    private final String simpleEntityVarName;
    private final String rawTableName;

    public RbacIdentityViewGenerator(final RbacView rbacDef, final String liquibaseTagPrefix) {
        this.rbacDef = rbacDef;
        this.liquibaseTagPrefix = liquibaseTagPrefix;
        this.simpleEntityVarName = rbacDef.getRootEntityAlias().simpleName();
        this.rawTableName = rbacDef.getRootEntityAlias().getRawTableName();
    }

    void generateTo(final StringWriter plPgSql) {
        plPgSql.writeLn("""
                -- ============================================================================
                --changeset ${liquibaseTagPrefix}-rbac-IDENTITY-VIEW:1 endDelimiter:--//
                -- ----------------------------------------------------------------------------
                call generateRbacIdentityView('${rawTableName}', $idName$
                    ${identityViewSqlPart}
                    $idName$);
                --//

                """,
                with("liquibaseTagPrefix", liquibaseTagPrefix),
                with("identityViewSqlPart", rbacDef.getIdentityViewSqlQuery().sql), // TODO: other part types
                with("rawTableName", rawTableName));
    }
}
